
#include <vcl.h>
#pragma hdrstop

#include "vmos.h"
#pragma package(smart_init)


//[2010.02.25.][!!!]{--------------------------------------------
//[] ̳ [˸ ]  ϴ []  Ѵ.
// ϰ Ҽ Ƿ   Ѵ.
// [˵]    IAR    BCB  ű̴.
//}--------------------------------------------------------------------


#include  "ring_buffer.h"


//------------------------------------------------------------------------------
//[DTU1 ]-------------------------------------------------------------------
//------------------------------------------------------------------------------

void RingBuf_Init(struct RING_BUFFER  *pRB)
{ 
  //[2009.08.27.][!!!]{------
  //[]  ʱȭ Ѵ.
  //}------------------------------

  //ڰ Ѵ.
  pRB->buf  = NULL;

  //ڰ Ѵ.
  pRB->size = 0;

  //ġ  ġȴ.
  pRB->wrInx = 0;

  //  ġ̹Ƿ ׻ ҳ ġ ´.
  pRB->rdInx = pRB->size - 1;

  //ó  ڷᰡ .
  pRB->count = 0;
   
}

void RingBuf_Create(struct RING_BUFFER  *pRB,
                    // MCU .
                    DTU8                 pBufMcuAdr,
                    // ũ.
                    DTU2                 pBufSize)
{ 
  //[2009.08.24.][!!!]{---
  //[]  Ѵ.
  //}---------------------------

  //ڰ Ѵ.
  pRB->buf  = (DTU1 *)pBufMcuAdr;

  //ڰ Ѵ.
  pRB->size = pBufSize;

  //ġ  ġȴ.
  pRB->wrInx = 0;

  //  ġ̹Ƿ ׻ ҳ ġ ´.
  pRB->rdInx = pRB->size - 1;

  //ó  ڷᰡ .
  pRB->count = 0;
   
}

void RingBuf_Clear(struct RING_BUFFER  *pRB)
{ 
  //[2009.08.27.][!!!]{----------------------------------------------
  //[]   .
  //̹  ũ ״ ΰ,  븸   ʱȭ Ѵ. 
  //}----------------------------------------------------------------------

  //ġ  ġȴ.
  pRB->wrInx = 0;

  //  ġ̹Ƿ ׻ ҳ ġ ´.
  pRB->rdInx = pRB->size - 1;

  //ó  ڷᰡ .
  pRB->count = 0;
   
}

DTU2 RingBuf_Count(struct RING_BUFFER  *pRB)
{
  //[2009.08.23.][!!!]{-------------------------------------------------
  // [] ȿ  ִ ڷ []  ؼ ȯѴ.
  // Լ ܺδ  Ƿ <RingBuf> θ ȴ.
  //}-------------------------------------------------------------------------

  if     (pRB->wrInx > pRB->rdInx)
  {
    return(pRB->wrInx - (pRB->rdInx + 1));

  }
  else// if(pRB->wrInx <= pRB->rdInx)
  {
    return((pRB->size - (pRB->rdInx + 1)) + pRB->wrInx);

  }

} 

void RingBuf_WrInxInc(struct RING_BUFFER  *pRB)
{
  //[2009.08.23.][!!!]{-------
  //[ġ]  ϳ  Ų.
  //}-------------------------------

  pRB->wrInx += 1;

  // Ѿٸ ٽ óġ ش.
  if(pRB->wrInx == pRB->size) { pRB->wrInx = 0; }

}

void RingBuf_RdInxInc(struct RING_BUFFER  *pRB)
{
  //[2009.08.23.][!!!]{-------
  //[бġ]  ϳ  Ų.
  //}-------------------------------

  pRB->rdInx += 1;

  // Ѿٸ ٽ óġ ش.
  if(pRB->rdInx == pRB->size) { pRB->rdInx = 0; }

}

bool RingBuf_Write(struct RING_BUFFER  *pRB,
                   DTU1                 pData)
{
  //[2009.08.23.][!!!]{------------
  //[]  ڷ 1   ִ´.
  //}------------------------------------

  //[VAR]
  //{
      DTU2  cnt; 

  //}

  //   Ѵ.
  cnt = RingBuf_Count(pRB);

  //  ΰ?(̹ ִٸ  ).
  //1   ׻ ܳƾ Ѵ.
  if(!((int)cnt < ((int)(pRB->size) - 1))) return(false);
     
  //  ġ .
  pRB->buf[pRB->wrInx] = pData;

  //  ġ ̵Ų.
  RingBuf_WrInxInc(pRB);
 
  //1 ߰ Ƿ 尳  Ų.
  pRB->count = ++cnt;

  return(true);

}

bool RingBuf_Read(struct  RING_BUFFER  *pRB,
                  DTU1                 *rData)
{
  //[2009.08.23.][!!!]{---------
  //[]  ڷ 1  .
  //}---------------------------------

  //[VAR]
  //{
      DTU2  cnt; 

  //}

  //   Ѵ.
  cnt = RingBuf_Count(pRB);

  //б  ΰ?(ִ ڷᰡ ϳ ٸ  ).
  // ʴ <Msg>  ȯѴ.
  if(!(cnt > 0)) { (*rData) = NULL; return(false); }

  // ġ ̵Ų(rdIndex  ׻   ġ ϹǷ).
  RingBuf_RdInxInc(pRB);

  //  ġ о ȯѴ
  (*rData) = pRB->buf[pRB->rdInx];
 
  //尳 1  Ų.
  pRB->count = --cnt;

  return(true);

}

//------------------------------------------------------------------------------
//[DTU8 ]-------------------------------------------------------------------
//------------------------------------------------------------------------------

void RingBuf8_Init(struct RING_BUFFER8  *pRB)
{
  //[2010.02.25.][!!!]{------
  //[]  ʱȭ Ѵ.
  //}------------------------------

  //ڰ Ѵ.
  pRB->buf  = NULL;

  //ڰ Ѵ.
  pRB->size = 0;

  //ġ  ġȴ.
  pRB->wrInx = 0;

  //  ġ̹Ƿ ׻ ҳ ġ ´.
  pRB->rdInx = pRB->size - 1;

  //ó  ڷᰡ .
  pRB->count = 0;
   
}

void RingBuf8_Create(struct RING_BUFFER8  *pRB,
                     // MCU .
                     DTU8                  pBufMcuAdr,
                     //[ ] ũ(1 Ʈ   ũⰡ ƴ϶ 8Ʈ  ).
                     DTU2                  pBufSize)
{ 
  //[2009.08.24.][!!!]{---
  //[]  Ѵ.
  //}---------------------------

  //ڰ Ѵ.
  pRB->buf  = (DTU8 *)pBufMcuAdr;

  //ڰ Ѵ.
  pRB->size = pBufSize;

  //ġ  ġȴ.
  pRB->wrInx = 0;

  //  ġ̹Ƿ ׻ ҳ ġ ´.
  pRB->rdInx = pRB->size - 1;

  //ó  ڷᰡ .
  pRB->count = 0;
   
}

void RingBuf8_Clear(struct RING_BUFFER8  *pRB)
{ 
  //[2009.08.27.][!!!]{----------------------------------------------
  //[]   .
  //̹  ũ ״ ΰ,  븸   ʱȭ Ѵ. 
  //}----------------------------------------------------------------------

  //ġ  ġȴ.
  pRB->wrInx = 0;

  //  ġ̹Ƿ ׻ ҳ ġ ´.
  pRB->rdInx = pRB->size - 1;

  //ó  ڷᰡ .
  pRB->count = 0;
   
}

DTU2 RingBuf8_Count(struct RING_BUFFER8  *pRB)
{
  //[2009.08.23.][!!!]{-------------------------------------------------
  // [] ȿ  ִ ڷ []  ؼ ȯѴ.
  // Լ ܺδ  Ƿ <RingBuf> θ ȴ.
  //}-------------------------------------------------------------------------

  if     (pRB->wrInx > pRB->rdInx)
  {
    return(pRB->wrInx - (pRB->rdInx + 1));

  }
  else// if(pRB->wrInx <= pRB->rdInx)
  {
    return((pRB->size - (pRB->rdInx + 1)) + pRB->wrInx);

  }

}

void RingBuf8_WrInxInc(struct RING_BUFFER8  *pRB)
{
  //[2009.08.23.][!!!]{-------
  //[ġ]  ϳ  Ų.
  //}-------------------------------

  pRB->wrInx += 1;

  // Ѿٸ ٽ óġ ش.
  if(pRB->wrInx == pRB->size) { pRB->wrInx = 0; }

}

void RingBuf8_RdInxInc(struct RING_BUFFER8  *pRB)
{
  //[2009.08.23.][!!!]{-------
  //[бġ]  ϳ  Ų.
  //}-------------------------------

  pRB->rdInx += 1;

  // Ѿٸ ٽ óġ ش.
  if(pRB->rdInx == pRB->size) { pRB->rdInx = 0; }

}

bool RingBuf8_Write(struct RING_BUFFER8  *pRB,
                    DTU8                  pData)
{
  //[2009.08.23.][!!!]{------------
  //[]  ڷ 1   ִ´.
  //}------------------------------------

  //[VAR]
  //{
      DTU2  cnt; 

  //}

  //   Ѵ.
  cnt = RingBuf8_Count(pRB);

  //  ΰ?(̹ ִٸ  ).
  //1   ׻ ܳƾ Ѵ.
  if(!((int)cnt < ((int)(pRB->size) - 1))) return(false);

  //  ġ .
  pRB->buf[pRB->wrInx] = pData;

  //  ġ ̵Ų.
  RingBuf8_WrInxInc(pRB);

  //1 ߰ Ƿ 尳  Ų.
  pRB->count = ++cnt;

  return(true);

}

bool RingBuf8_Read(struct  RING_BUFFER8  *pRB,
                   DTU8                  *rData)
{
  //[2009.08.23.][!!!]{---------
  //[]  ڷ 1  .
  //}---------------------------------

  //[VAR]
  //{
      DTU2  cnt; 

  //}

  //   Ѵ.
  cnt = RingBuf8_Count(pRB);

  //б  ΰ?(ִ ڷᰡ ϳ ٸ  ).
  // ʴ <Msg>  ȯѴ.
  if(!(cnt > 0)) { (*rData) = NULL; return(false); }

  // ġ ̵Ų(rdIndex  ׻   ġ ϹǷ).
  RingBuf8_RdInxInc(pRB);

  //  ġ о ȯѴ
  (*rData) = pRB->buf[pRB->rdInx];

  //尳 1  Ų.
  pRB->count = --cnt;

  return(true);

}

//------------------------------------------------------------------------------
//[class:VRingBuf]--------------------------------------------------------------
//------------------------------------------------------------------------------
             
void __fastcall VRING_BUFFER::RingBuf_Init(void)
{
  //[2018.11.01.][!!!]{------
  //[]  ʱȭ Ѵ.
  //}------------------------------

  //ڰ Ѵ.
  buf  = NULL;

  //ڰ Ѵ.
  size = 0;

  //ġ  ġȴ.
  wrInx = 0;

  //(wrInx == rdInx)    0.
  rdInx = 0;

  //ó  ڷᰡ .
  count = 0;

  //[2018.11.04.][߰!!!]
  rxPos = wrInx;
   
}

void __fastcall VRING_BUFFER::RingBuf_Create(// MCU .
                                             DTU8  pBufMcuAdr,
                                             // ũ.
                                             DTU4  pBufSize)
{
  //[2018.11.01.][!!!]{---
  //[]  Ѵ.
  //}---------------------------

  //ڰ Ѵ.
  buf  = (DTU1 *)pBufMcuAdr;

  //ڰ Ѵ.
  size = pBufSize;

  //ġ  ġȴ.
  wrInx = 0;

  //(wrInx == rdInx)    0.
  rdInx = 0;

  //ó  ڷᰡ .
  count = 0;

  //[2018.11.04.][߰!!!]
  rxPos = wrInx;

}

void __fastcall VRING_BUFFER::RingBuf_Clear(void)
{
  //[2018.11.01.][!!!]{----------------------------------------------
  //[]   .
  //̹  ũ ״ ΰ,  븸   ʱȭ Ѵ. 
  //}----------------------------------------------------------------------

  //ġ  ġȴ.
  wrInx = 0;

  //(wrInx == rdInx)    0.
  rdInx = 0;

  //ó  ڷᰡ .
  count = 0;

  rxPos = wrInx;

}

DTU4 __fastcall VRING_BUFFER::RingBuf_Count(void)
{
  //[2018.11.01.][!!!]{-------------------------------------------------
  // [] ȿ  ִ ڷ []  ؼ ȯѴ.
  // Լ ܺδ  Ƿ <RingBuf> θ ȴ.
  //
  //[尳:ϱ]*********************************************************
  //
  //1) (rdInx == wrInx) : 尳 0( ).
  //
  //2) (rdInx > wrInx)  : (size - rdInx) + wrInx;
  //
  //3) (rdInx < wrInx)  : wrInx - rdInx;
  //
  //}-------------------------------------------------------------------------

  if     (rdInx == wrInx) { return(0); /*  */ }
  else if(rdInx >  wrInx) { return((size - rdInx) + wrInx); }
  else if(rdInx <  wrInx) { return(wrInx - rdInx);          }

} 

void __fastcall VRING_BUFFER::RingBuf_WrInxInc(void)
{
  //[2018.11.01.][!!!]{-------
  //[ġ]  ϳ  Ų.
  //}-------------------------------

  wrInx += 1;

  // Ѿٸ ٽ óġ ش.
  if(wrInx == size) { wrInx = 0; }

}

void __fastcall VRING_BUFFER::RingBuf_RdInxInc(void)
{
  //[2018.11.01.][!!!]{-------
  //[бġ]  ϳ  Ų.
  //}-------------------------------

  rdInx += 1;

  // Ѿٸ ٽ óġ ش.
  if(rdInx == size) { rdInx = 0; }

}

bool __fastcall VRING_BUFFER::RingBuf_Write(DTU1  pData)
{
  //[2018.11.01.][!!!]{-------------------------------------------
  //[]  ڷ 1   ִ´.
  //
  //[!!!]************************************************************
  //1) full  <size - 1>  ǹ. , 1  ݵ  ƾ Ѵ.
  //2) wrInx  rdInx  ų(尳 0  ) ߿Ҽ .
  //}--------------------------------------------------------------------

  //[VAR]
  //{
      DTU4  cnt;

  //}

  //[  ΰ?]
  //{
      //   Ѵ.
      cnt = RingBuf_Count();

      //1 Ʈ  --------v
      //  1 Ʈ.
      //----------v
      if(!((cnt + 1) <= (size - 1))) return(false);

  //}    

  //  ġ .
  buf[wrInx] = pData;

  //  ġ ̵Ų.
  RingBuf_WrInxInc();
 
  //1 ߰ Ƿ 尳  Ų.
  count = ++cnt;

  return(true);

}

bool __fastcall VRING_BUFFER::RingBuf_WriteX(DTU1  *pData,
                                             DTU4   pSize,
                                             //  . 
                                             DTU4  *rRealCount)
{
  //[2018.11.01.][!!!]{------------------------------------------------------
  //[]  [ڷ῭]  [:] ŭ ִ´.
  //
  //,    <rRealCount:NULL>   ó ʰ ٷ ϰ
  //ƴ     ä    <rRealCount>  ȯ.
  //  return(false)  ȴ.
  //
  //   <pSize> ŭ ϰ return(true);
  //
  //, <rRealCount:NULL> ο  2   óѴ.
  //}------------------------------------------------------------------------------

  //[VAR]
  //{
      DTU4  cnt;

      int   i;

  //}

  //[  ]
  //{
      cnt = RingBuf_Count();

  //}

  if((cnt + pSize) <= (size - 1))
  {
    //[!]{------------------------------------------------
    //<pSize>      ״ .
    //}---------------------------------------------------

    //[]
    //{
        for(i = 0; i < pSize; i++)
        {
          RingBuf_Write(pData[i]);

        }

    //}    

    //[   ȯ]
    //{
        if(rRealCount != NULL)
        {
          //   <pSize>  .
          (*rRealCount) = pSize;

        }

    //}

    return(true);

  }
  else
  {
    //[!]{-----------------------------------------------
    //[ ]  <pSize>     ó.
    //   ⺻ return(false).
    //}--------------------------------------------------

    if(rRealCount == NULL)
    {
      //  ƹ͵  ʰ ٷ .
      return(false);

    }
    else
    {
      //[!]{----------------------------------------------
      //   ä,   ũ⸦ ȯ.
      //}-------------------------------------------------

      //[]
      //{
          //[!]{---------------------------------------------------
          //   ʰ ̻ Ҽ 
          // ϴ  .
          //}------------------------------------------------------

          for(i = 0; i < pSize; i++)
          {
            //̻ Ҽ  .
            if(RingBuf_Write(pData[i]) != true) break;

          }

      //}

      //[   ȯ]
      //{
          // <i>    ũⰡ ȴ.
          (*rRealCount) = i;

      //}

      return(false);

    }

  }

}

bool __fastcall VRING_BUFFER::RingBuf_Read(DTU1  *rData)
{
  //[2018.11.01.][!!!]{-----------------------------------------------------------
  //[]  ڷ 1  .
  //
  //[2018.10.04.][߿!!!]********************************************************
  //<rdInx> ġ  д  .
  // [] ó <rxInx:  ġ>  ƴ϶ [ġ]  ƴ.
  //
  //[2018.11.16.][!!!]************************************************************
  //<rData:NULL>   [о ]  ϰ, ⺻ ó ״ ϳ
  //ڷ ȯ ʴ´.
  //}-----------------------------------------------------------------------------------

  //[VAR]
  //{
      DTU4  cnt;

  //}

  //[б  ΰ?]
  //{
      //   Ѵ.
      cnt = RingBuf_Count();

      //б  ΰ?(ִ ڷᰡ ϳ ٸ  ).
      // ʴ <Msg>  ȯѴ.
      if(!(cnt > 0))
      {
        if(rData != NULL) { (*rData) = NULL; }

        return(false);

      }

  //}

  //[ڷ ȯ]
  //{
      //[2018.11.16.][!!!]{--------------------------------------------------
      //<rData:NULL>   [о ]  ϰ ڷ ȯ ʴ´.
      //}--------------------------------------------------------------------------

      if(rData != NULL)
      {
        // <rdInx>  о ȯ.
        (*rData) = buf[rdInx];

      }
      else
      {
        //[!]{----------------------------------------------------------------
        //<rData:NULL>   ó ״  ڷ ȯ ʴ´.
        //, [о ]  ó.
        //}-------------------------------------------------------------------

      }

  //}

  // [ġ]  ̵.
  RingBuf_RdInxInc();

  //[!!!]{---------------------------------------------------------------
  //  1  ۿ  ڷḦ оٸ ⼭ <rxInx == wrInx>  ǰ
  //[Ȱ ] ° ȴ.
  //}------------------------------------------------------------------------

  //尳 1  Ų.
  count = --cnt;

  return(true);

}

bool __fastcall VRING_BUFFER::RingBuf_ReadX(DTU1  *rData,
                                            DTU4   pSize,
                                            //  .
                                            DTU4  *rRealCount)
{
  //[2018.11.01.][!!!]{-------------------------------------------------------------
  //[]  [:]  [ڷ῭]  о ȯ.
  //
  //, ϵ    <rRealCount:NULL>   ó ʰ ٷ ϰ
  //ƴ  ϵ  о ̰    <rRealCount>  ȯ.
  //  return(false)  ȴ.
  //
  //<pSize>  ϵ    <pSize> ŭ о̰ return(true).
  //
  //, <rRealCount:NULL> ο  2   óѴ.
  //
  //[2018.11.16.][!!!]**************************************************************
  //<rData:NULL>   [о ]  ϰ, ⺻ ó ״ ϳ
  //ڷ ȯ ʴ´.
  //}-------------------------------------------------------------------------------------

  //[VAR]
  //{
      DTU4  cnt;

      int   i;

  //}

  //[  ]
  //{
      cnt = RingBuf_Count();

  //}

  if(cnt >= pSize)
  {
    //[!]{-----------------------------------------------------------
    //<pSize> ŭ  оϼ ִٸ <pSize> ŭ оδ.
    //}--------------------------------------------------------------

    //[б]
    //{
        for(i = 0; i < pSize; i++)
        {
          if(rData != NULL)
          {
            RingBuf_Read(&(rData[i]));

          }
          else
          {
            //[2018.11.16.][߰!!!]{----------------------------------------------
            //<rData:NULL>   <rdInx>   Ҵ ״ ؾ ϹǷ
            //<RingBuf_Read()>  <NULL>  óѴ.
            //[о ]  <RingBuf_Read()>   ִ.
            //}----------------------------------------------------------------------
            
            RingBuf_Read(NULL);

          }

        }

    //}    

    //[   ȯ]
    //{
        if(rRealCount != NULL)
        {
          //   <pSize>  .
          (*rRealCount) = pSize;

        }

    //}

    return(true);

  }
  else
  {
    //[!]{-----------------------------------------------
    //[ ]  <pSize>     ó.
    //    ⺻ return(false).
    //}--------------------------------------------------

    if(rRealCount == NULL)
    {
      //  ƹ͵  ʰ ٷ .
      return(false);

    }
    else
    {
      //[!]{---------------------------------------------------------
      //    о̰,  о  ȯ.
      //}------------------------------------------------------------

      //[б]
      //{
          //[!]{-----------------------------------------------
          //   ʰ ̻  
          // о̴  .
          //}--------------------------------------------------

          for(i = 0; i < pSize; i++)
          {
            if(rData != NULL)
            {
              //̻   .
              if(RingBuf_Read(&(rData[i])) != true) break;

            }
            else
            {
              //[2018.11.16.][߰!!!]{----------------------------------------------
              //<rData:NULL>   <rdInx>   Ҵ ״ ؾ ϹǷ
              //<RingBuf_Read()>  <NULL>  óѴ.
              //[о ]  <RingBuf_Read()>   ִ.
              //}----------------------------------------------------------------------

              //̻   .
              if(RingBuf_Read(NULL) != true) break;

            }

          }

      //}

      //[   ȯ]
      //{
          // <i>     ȴ.
          (*rRealCount) = i;

      //}

      return(false);

    }

  }

}

bool __fastcall VRING_BUFFER::RingBuf_DataArea_Check(DTU4  pIndex)
{
  //[2018.11.05.][!!!]{----------------------------------------------------
  //<pIndex>  [ڷ῵] ̶ return(true), ̶ return(false).
  //
  // { rdInx <= pIndex <= wrInx }   ġϴ ˻ϴ°.
  //
  //<wrInx> ġ  ġ  [ڷ῵]   ġ [Undo/Redo] 
  //Ǽ Ͽ <=> 쵵 ϴ [ ģ]  .
  //<rxPos>   <wrInx> ġ ϰ ϴ 찡 κ̱ .
  //}----------------------------------------------------------------------------

  if     (rdInx == wrInx)
  {
    //    [ڷ῵]  ƿ .
    return(false);

  }
  else if(rdInx > wrInx)
  {
    if(((rdInx <= pIndex) && (pIndex < size)) || ((0 <= pIndex) && (pIndex <= wrInx))) return(true);
    else                                                                               return(false);

  }
  else if(rdInx < wrInx)
  {
    if((rdInx <= pIndex) && (pIndex <= wrInx)) return(true);
    else                                       return(false);

  }

}

void __fastcall VRING_BUFFER::RingBuf_Info(//ڷ   ġ( ڷ  ġ).
                                           DTU4  *rWrInx,
                                           //ڷ   ġ(ڷ  ġ).
                                           DTU4  *rRdInx,
                                           //<_VRingBufRead_XXX()> Լ ϴ  ġ.
                                           DTU4  *rRxPos,
                                           //  ڷᰳ.
                                           DTU4  *rCount)
{
  //[2018.11.05.][!!!]{---------------
  // []   ȯ.
  //<Undo/Redo>     .
  //
  //NULL  ƴ  ó.
  //}---------------------------------------

  if(rWrInx != NULL) { (*rWrInx) = wrInx; }

  if(rRdInx != NULL) { (*rRdInx) = rdInx; }

  if(rRxPos != NULL) { (*rRxPos) = rxPos; }

  if(rCount != NULL) { (*rCount) = count; }

}


bool __fastcall VRING_BUFFER::RingBufRead_RxPos_Set(//{ 0 <= pRxPos < size }
                                                    DTU4  pRxPos)
{
  //[2018.11.05.][!!!]{------------------------------------------------
  //<pRxPos> .
  //<_VRingBufRead_XXX()> Լ   ġ.
  //<pRxPos>  [ڷ῵]   return(true), ̶ return(false).
  //{ 0 <= pRxPos < size }  ƴ 쵵  return(false);
  //}------------------------------------------------------------------------

  if((0 <= pRxPos) && (pRxPos < size))
  {
    //[!]{------------------------------------------------------------
    //[] ̶ ⺻  [ڷ῵:/]  .
    //}---------------------------------------------------------------

    //.
    rxPos = pRxPos;

    // ˻   ȯ.
    return(RingBuf_DataArea_Check(pRxPos));

  }
  else
  {
    //⺻ [] ȿ  ʴ ġ.
    return(false);

  }

}

void __fastcall VRING_BUFFER::RingBufRead_RxPos_Set_WrInx(void)
{
  //[2018.11.05.][!!!]{-----------------------------------------------------------------
  //wrInx = rxPos   .
  //Undo ڿ ο  ٽ ߰ϴ , ο   ġ ϱ Ͽ .
  //  .
  //}-----------------------------------------------------------------------------------------

  wrInx = rxPos;

}

void __fastcall VRING_BUFFER::RingBufRead_RxPosInc(void)
{
  //[2018.11.04.][!!!]{----
  //[бġ]  ϳ .
  //}----------------------------

  rxPos += 1;

  // Ѿٸ ٽ óġ ش.
  if(rxPos == size) { rxPos = 0; }

}

bool __fastcall VRING_BUFFER::RingBufRead_Read(DTU1  *rData)
{
  //[2018.11.04.][!!!]{-------------------------------------------------
  //[]  <rxPos> ġ  ϳ .
  //[] ü ƹ   ʴ´.
  //
  //[!!!]*****************************************************************
  //[ڷ]   ִ    return(true),
  //[ڷ]  ̶ return(false) ȯ.
  //
  //[߿!!!]*****************************************************************
  //{ rdInx <= [ڷ῵] <= wrInx }  <wrInx>  Եǵ ǵ 
  //<wrInx> ġ   .
  //, <RingBuf_Read()>   []  б  θ Ǵ ʰ
  //<rxPos == wrInx>   ̻    Ѵ.
  //
  //[2018.11.16.][!!!]**************************************************
  //<rData:NULL>   [о ]  ϰ ⺻ ó ״
  //ϳ ڷ ȯ ʴ´.
  //}-------------------------------------------------------------------------

  //[ ִ  Ȯ]
  //{
      //[  ]{--------------------------------------
      //
      //1) <rxPos>  [ڷ῵:]  ִ .
      //
      //2) [ڷ῵:]  ġ <rxPos == wrInx>  .
      //
      //}--------------------------------------------------------

      if(RingBuf_DataArea_Check(rxPos) == true)
      {
        //[ڷ῵:]  ̻  ([ڷ῵:]  ش).
        if(rxPos == wrInx) return(false);

      }
      else
      {
        return(false);

      }
      
  //}

  //[б]
  //{
      if(rData != NULL)
      {
        //  ġ о ȯѴ.
        (*rData) = buf[rxPos];

      }
      else
      {
        //[!]{----------------------------------------------------------------
        //<rData:NULL>   ó ״  ڷ ȯ ʴ´.
        //, [о ]  ó.
        //}-------------------------------------------------------------------

      }

      // ġ ̵(rxPos  <rxInx>  ޸ ׻  ġ ).
      RingBufRead_RxPosInc();

  //}
      
  return(true);

}

bool __fastcall VRING_BUFFER::RingBufRead_ReadX(DTU1  *rData,
                                                DTU4   pSize,
                                                //  (̻ NULL).
                                                DTU4  *rRealCount)
{
  //[2018.11.04.][!!!]{------------------------------------------------------
  // <rxPos> ġ <pSize> ŭ а <rxPos>  <pSize> ŭ  ̵.
  //[Redo] 信 ش.
  //
  //rxPos = rxPos + pũ.
  //̻   return(false);
  //
  //[߿!!!]**********************************************************************
  //<rxPos>  <RingBufRead_RxPos_Set()>   ǰ ϹǷ ó
  //return(false)  ϴ   ġ ״ д.
  //
  //[!!!][2018.11.09.][!!!]**********************************************
  //<rxPos == wrInx>   [ڷ῵]   ̻  .
  //<RingBufRead_Read()>  ڵ óȴ.
  //
  //[2018.11.16.][!!!]*******************************************************
  //<rData:NULL>   [о ]  ϰ ⺻ ó ״
  //ϳ ڷ ȯ ʴ´.
  //}------------------------------------------------------------------------------

  //[VAR]
  //{
      int  i;

  //}

  //[б]
  //{
      for(i = 0; i < pSize; i++)
      {
        if(rData != NULL)
        {
          if(RingBufRead_Read(&(rData[i])) != true)
          {
            //[2018.11.09.][߰!!!]{--------------------------------------------------
            //ݵ ó  0  .
            //׷     ó   ִ  
            //  ״  ְ Ǿ  ó ִ  Ҽ .
            if(rRealCount != NULL) { (*rRealCount) = 0; }
            //}--------------------------------------------------------------------------

            return(false);

          }

        }
        else
        {
          //[2018.11.16.][߰!!!]{----------------------------------------------
          //<rData:NULL>   <rxPos>   Ҵ ״ ؾ ϹǷ
          //<RingBufRead_Read()>  <NULL>  óѴ.
          //[о ]  <RingBufRead_Read()>   ִ.
          //}----------------------------------------------------------------------

          if(RingBufRead_Read(NULL) != true)
          {
            //[2018.11.09.][߰!!!]{--------------------------------------------------
            //ݵ ó  0  .
            //׷     ó   ִ  
            //  ״  ְ Ǿ  ó ִ  Ҽ .
            if(rRealCount != NULL) { (*rRealCount) = 0; }
            //}--------------------------------------------------------------------------

            return(false);

          }

        }

        //[ ]
        //{
            //[!]{---------------------------------
            //    .
            //1  ؼ [index => ]  ȯ.
            //}------------------------------------

            if(rRealCount != NULL) { (*rRealCount) = (i + 1); }

        //}

      }

  //}

  return(true);

}

bool __fastcall VRING_BUFFER::RingBufRead_ReadX_Back(DTU1  *rData,
                                                     DTU4   pSize,
                                                     //  (̻ NULL).
                                                     DTU4  *rRealCount)
{
  //[2018.11.04.][!!!]{-----------------------------------------------------------
  // <rxPos> ġ  <pSize> ŭ а <rxPos>  <pSize> ŭ  ̵.
  //[Undo] 信 ش.
  //
  //rxPos = rxPos - pũ. 
  //̻   return(false);
  //
  //[!!!]***************************************************************************
  // Լ <rRealCount>  ׻ <pSize> ϼ ۿ .
  //<rxPos>  <pSize> ŭ   о̱ .
  //, <rxPos>  <pSize> ŭ  ġ [ڷ῵:]   ɷ Ѵ.
  //
  //[߿!!!]***************************************************************************
  //<rxPos>  <RingBufRead_RxPos_Set()>   ǰ ϹǷ ó
  //return(false)  ϴ   ġ ״ д.
  //
  //[2018.11.16.][!!!]************************************************************
  //<rData:NULL>   [о ]  ϰ ⺻ ó ״
  //ϳ ڷ ȯ ʴ´.
  //}-----------------------------------------------------------------------------------

  //[VAR]
  //{
      int   rxPos_Save;

      //[2018.11.05.][߰!!!]
      int   tempRxPos;

      int   i;

  //}

  //[ġ ]
  //{
      //[!]{----------------------------------------------------------------------------------
      //б  ġ .
      //ڷ῭ [size - 1][0]  迡  Ƿ ̸  ó.
      //
      //[!!!][2018.10.09.][!!!]-----------------------------------------------------
      //Ʒ Ǻ κп [(-)]  ü Ƿ  ݵ (int)  ȯ .
      //}-------------------------------------------------------------------------------------

      if(((int)rxPos - (int)pSize) >= 0) { tempRxPos = rxPos - pSize;          }
      else                               { tempRxPos = size - (pSize - rxPos); }

      //[ڷ῵  Ȯ]
      //{
          if(RingBuf_DataArea_Check(tempRxPos) == true)
          {
            //[!]{--------------------------------------------------------------
            // ִ [ڷ῵] ̹Ƿ <rxPos>    ġ .
            //}-----------------------------------------------------------------
            
            rxPos = tempRxPos;

          }
          else
          {
            //[!]{----------------------------------
            //[ڷ῵:]  Ƿ .
            //ƿ  ʾǷ 0 ȯ.
            //̻  ʰ ٷ .
            //}-------------------------------------
            
            if(rRealCount != NULL) { (*rRealCount) = 0; }

            return(false);

          }

      //}

  //}

  //[]
  //{
      //[!]{---------------------------------------------------------------------
      //<RingBufRead_Read()>  <rxPos> ġ  ̵ϹǷ  ġ .
      //}------------------------------------------------------------------------
      
      rxPos_Save = rxPos;

  //}

  //[б]
  //{
      for(i = 0; i < pSize; i++)
      {
        if(rData != NULL)
        {
          if(RingBufRead_Read(&(rData[i])) != true) goto lbFalse;

        }
        else
        {
          //[2018.11.16.][߰!!!]{----------------------------------------------
          //<rData:NULL>   <rxPos>   Ҵ ״ ؾ ϹǷ
          //<RingBufRead_Read()>  <NULL>  óѴ.
          //[о ]  <RingBufRead_Read()>   ִ.
          //}----------------------------------------------------------------------

          if(RingBufRead_Read(NULL) != true) goto lbFalse;

        }

        //[ ]
        //{
            //[!]{---------------------------------
            //    .
            //1  ؼ [index => ]  ȯ.
            //}------------------------------------

            if(rRealCount != NULL) { (*rRealCount) = (i + 1); }

        //}

      }

  //}

  //[]
  //{
      //[!]{---------------------------------------------------------------------------
      //<RingBufRead_Read()>   <rxPos>  ̵Ƿ  ġ 缳.
      //[Undo]  б  ġ <rxPos>  ġ ־ Ѵ.
      //}------------------------------------------------------------------------------
      
      rxPos = rxPos_Save;

  //}

  lbTrue:
  //{
      return(true);

  //}

  lbFalse:
  //{
      //б   쿡 ⺻ <rxPos>  [бġ]   ƾ Ѵ.
      rxPos = rxPos_Save;

      return(false);

  //}

}

void __fastcall VRingBuf_Create(//ü   [].
                                void  *pPart_,
                                //[]  [BCB]  ּ.
                                DTU8   pBufAdr,
                                // ũ.
                                DTU4   pBufSize)
{
  //[2018.11.01.][!!!]{---------------------------------------------
  //[] .
  //
  // []  [˵-C]  ϸ  []  ޹޾ ó.
  //
  //[8] = { [ּ(8)] }
  //
  // GUI  ޸ []  [VRingBuf]  PC  [ּ]  ´.
  //}---------------------------------------------------------------------

  //[VAR]
  //{
      // ü.
      class VRING_BUFFER  *VRingBuf_ = NULL;

  //}

  //[]
  //{
      VRingBuf_ = new VRING_BUFFER;

  //}

  //[ʱȭ]
  //{
      //[!!!]{*************************************************
      //ݵ <RingBuf_Init()> => <RingBuf_Create()>  ó.
      //}**********************************************************
      
      VRingBuf_->RingBuf_Init();

      VRingBuf_->RingBuf_Create(pBufAdr, pBufSize);

  //}

  //[<>  ]
  //{
      //[!]{-------------------------------------------------------
      //[8] = { [ּ(8)] }
      //
      //VRING_BUFFER ڴ   [ּ(8)]  .
      //}----------------------------------------------------------

      //  ü ġ (PC  ).
      //̴ <VRingBuf_Delete()>   []  Ѱ.
      (*((DTU8 *)pPart_)) = (DTU8)VRingBuf_;

  //}

}

void __fastcall VRingBuf_Delete(//ü .
                                void  *pPart_)
{
  //[2018.11.01.][!!!]{---
  // [] .
  //}---------------------------

  //[VAR]
  //{
      // ü.
      class VRING_BUFFER  *VRingBuf_ = NULL;

  //}

  //[ü ġ ]
  //{
      //  .
      VRingBuf_ = (VRING_BUFFER *)(*((DTU8 *)pPart_));

  //}

  //[]
  //{
      //̹  ִ 츸 óѴ.
      if(VRingBuf_ != NULL) { delete VRingBuf_; VRingBuf_ = NULL; }

  //}

  //[  ʱȭ]
  //{
      //[!]{-------------------------------------------
      // ü Ƿ []  ʱȭ.
      //}----------------------------------------------

      //  ü ġ (PC  ).
      (*((DTU8 *)pPart_)) = 0;

  //}  

}

                                

